/*
 Copyright 2005-2007 Foxmarks Inc.

 foxmarks-dialog.js: Implements the main foxmarks options dialog.

 */

// TO DO:
// * Use synchronize method for preferences

function SetupDialog() {
    var d = document;
    var fms = Cc["@foxcloud.com/extensions/foxmarks;1"].
        getService(Ci.nsIFoxmarksService);

    // Set styles for Mac OS X
    if (navigator.platform.toLowerCase().indexOf('mac') > -1) {
        d.getElementById("foxmarks-settings").className = "macosx";
    }

    // Settings that are too complex to handle via prefwindow
    d.getElementById("password").value = fms.getPassword(false);
    d.getElementById("synconshutdown").checked = gSettings.syncOnShutdown;
    d.getElementById("askfirst").checked = gSettings.syncOnShutdownAsk;

    // Info that is read-only
    d.getElementById("lastSynchDate").value = gSettings.lastSynchDisplayDate;

    d.getElementById("version").value = "Foxmarks Bookmark Synchronizer v"
        + FoxmarksVersion();

    // Make sure we enable-disable as appropriate...
    SyncOnShutdownChanged();
    UseOwnServerChanged();
}

function StoreSettingsFromDialog() {
    var d = document;
    var fms = Cc["@foxcloud.com/extensions/foxmarks;1"].
        getService(Ci.nsIFoxmarksService);

    // Handle complex settings not handled by prefwindow
    fms.setPassword(d.getElementById("password").value);
}

function doOK() {
    StoreSettingsFromDialog();
    return true;
}

function doHelp() {
    OpenFileInWindow("http://wiki.foxmarks.com/wiki/Foxmarks:_Help");
}

function PerformAction(action, arg) {
    var retval = { helpurl: null };

    try {
        var win = window.openDialog(
            "chrome://foxmarks/content/foxmarks-progress.xul", "_blank",
            "chrome,dialog,modal,centerscreen", action, retval, arg);
        SetupDialog();  // update last synched date
        if (retval.helpurl)
            OpenFileInWindow(retval.helpurl);
    } catch (e) {
        alert(e);
    }
}

function UploadNow() {
    if (confirm(Bundle().GetStringFromName("msg.overwriteremote"))) {
        StoreSettingsFromDialog();
        PerformAction("upload", null);
    }
}

function DownloadNow() {
    if (confirm(Bundle().GetStringFromName("msg.overwritelocal"))) {
        StoreSettingsFromDialog();
        PerformAction("download", null);
    }
}

function SynchronizeNow() {
    StoreSettingsFromDialog();
    PerformAction("synch", null);
}

function OpenFileInWindow(url) {
    openDialog("chrome://browser/content/browser.xul", "_blank",
        "chrome,all,dialog=no", url);
}

function RunSetupWizard() {
    StoreSettingsFromDialog();
    window.open("chrome://foxmarks/content/foxmarks-setup.xul", "_blank",
        "chrome,centerscreen,modal");
    SetupDialog();
}


function DisplayLogFile() {
    var ios = Cc["@mozilla.org/network/io-service;1"].
        getService(Ci.nsIIOService);
    var file = Cc['@mozilla.org/file/directory_service;1']
        .getService(Ci.nsIProperties) .get('ProfD', Ci.nsIFile);

    file.append("foxmarks.log");
    uri = ios.newFileURI(file);
    OpenFileInWindow(uri.spec);
}

function SyncOnShutdownChanged() {
    document.getElementById("askfirst").disabled =
        !document.getElementById("synconshutdown").checked;
}


function SyncOnShutdownToPreference() {
    if (document.getElementById("synconshutdown").checked) {
        return 1;
    }
    return 0;
}

function UseOwnServerChanged() {
    var uo = document.getElementById("useown").checked;
    document.getElementById("url").disabled                 = !uo;
    document.getElementById("useown-url-label").disabled    = !uo;
    document.getElementById("encrypt").disabled             = uo;
}
