/* 
 Copyright 2005-2007 Foxmarks Inc.
 
 foxmarks-setup.js: implements behavior for the Foxmarks Setup Wizard.
   
 */


function SetupOnLoad() {
    var fms = Cc["@foxcloud.com/extensions/foxmarks;1"].
        getService(Ci.nsIFoxmarksService);

    // if we're re-running the wizard for some reason, get
    // the current settings
    document.getElementById("username").value = gSettings.username;
    document.getElementById("password").value = fms.getPassword(false);
    document.getElementById("remember").checked = gSettings.rememberPassword;
}

function SetupValidateLogin() {
    var fms = Cc["@foxcloud.com/extensions/foxmarks;1"].
        getService(Ci.nsIFoxmarksService);

    gSettings.username = document.getElementById("username").value;
    gSettings.rememberPassword = document.getElementById("remember").checked;
    fms.setPassword(document.getElementById("password").value);

    var retval = {};

    PerformAction("status", retval);
    var result = retval.result;
    if (result.status) {
        var sb = Bundle();

        if (result.status == 401 || result.status == 403) {
            alert(sb.GetStringFromName("msg.invalidlogin"));
        } else {
            alert(result.msg);
        }
        return false;
    }

    gIsEmpty = result.isreset == "true" || result.isreset == true;
    return true;
}


function SetupIsMerging() {
    return !gIsEmpty && 
        document.getElementById("localOrRemote").selectedItem.value == "merge";
}

// Skip over sync options if gIsEmpty.
function SetupVerifyNext() { 
    if (gIsEmpty) {
        document.documentElement.goTo("execute");
        return false;
    }
    return true;
}

// Skip over merge options if the user hasn't selected merge.
function SetupOptionNext() {
    if  (!SetupIsMerging()) {
        document.documentElement.goTo("execute");
        return false;
    }
    return true;
}

// Go all the way back to verified if gIsEmpty.
// Skip back to primary sync option if user isn't merging.
function SetupExecuteBack() {
    if (gIsEmpty) {
        document.documentElement.goTo("verified");
        return false;
    } else if (!SetupIsMerging()) {
        document.documentElement.goTo("selectSyncOption");
        return false;
    }

    return true;
}

function SetupShowExecutePage() {
    var op;
    var a = document.getElementById("localOrRemote").selectedItem.value;
    var b = document.getElementById("mergeStart").selectedItem.value;

    if (gIsEmpty) {
        op = "msg.upload";
    } else {
        if (a == "local") {
            op = "msg.upload";
        } else if (a == "remote") {
            op = "msg.download";
        } else {
            if (b == "local") {
                op = "msg.mergelocal";
            } else {
                op = "msg.mergeremote";
            }
        }
    }
    document.getElementById("operation").value = Bundle().GetStringFromName(op);
    if (!gIsEmpty && a != "merge") {
        document.getElementById("warning").value =
            Bundle().GetStringFromName(op + ".warning");
    } else {
        document.getElementById("warning").value = null;
    }
}

function SetupPerformSync() {
    var retval = {}
    var args = {};

    var a = document.getElementById("localOrRemote").selectedItem.value;
    var b = document.getElementById("mergeStart").selectedItem.value;

    args.merge = SetupIsMerging();
    args.remoteIsMaster = gIsEmpty ? false :
        (args.merge ? (b == "remote") : (a == "remote"));

    PerformAction("initialSync", retval, args);

    if (!retval.status) {
        return true;
    } else {
        alert(Bundle().formatStringFromName("msg.syncfailed", [retval.msg], 1));
    }

    return false;
}

function PerformAction(action, retval, args) {
    var win = window.
            openDialog("chrome://foxmarks/content/foxmarks-progress.xul",
            "_blank", "chrome,dialog,modal,centerscreen", action, retval, args);

    if (retval.helpurl) {
        openDialog("chrome://browser/content/browser.xul", "_blank",
            "chrome,all,dialog=no", url);
        retval.status = -1;
        retval.msg = Bundle().GetStringFromname(msg.cancelled);
    }

    return;
}

function SetupOnWizardCancel() {
    var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
        .getService(Components.interfaces.nsIPromptService);

    var checkResult = {};
    checkResult.value = gSettings.wizardSuppress;
    var sb = Bundle();

    // Show a confirmation dialog with a check box. Arguments in order are: 
    // the parent  window, the dialog title, the dialog message, the check box 
    // label and a result object for the check box state.
    var ret = ps.confirmCheck(window, sb.GetStringFromName("title.cancelsetup"),
            sb.GetStringFromName("msg.cancelsetup"),
            sb.GetStringFromName("msg.nowizard"),
            checkResult);

    gSettings.wizardSuppress = checkResult.value;

    return ret;
}

function SetupOnWizardFinish() {
    gSettings.wizardSuppress = true;  // don't need to auto launch again
    gSettings.majorVersion = 2;
    return true;
}
